;********************Define chapter************************************************** 
.def   temp   =r16
.def   temp2  =r17

.def   coarse =r21
.def   medium =r22
.def   fine   =r23
;**********************Const chapter******************************************
.equ   c_del       =1
.equ   m_del       =100
.equ   f_del       =255

.include "2313def.inc"
;*********************************Code segment********************************
.cseg	                         
.org 0
          rjmp reset

reset:
        ldi Temp,RamEnd			;Stack init
        out SPL,Temp			;---//-----
		     
		ldi temp,0xff			;I/O ports init
		out DDRB, temp
		out PORTB, temp
		ldi temp,0x7f
		out DDRD, temp
		out PORTD, temp
main:							;main cycle
        ldi temp,0xfe
		ldi temp2,0x08
for1:							;Flashes PORTB LEDs
		out PORTB,temp
		sec
		rol temp
		rcall delay

        dec temp2
		cpi temp2, 0x00
		brne for1

		ldi temp,0xff
		out PORTB, temp

        ldi temp,0x7e
		ldi temp2,0x07
for2:							;Flashes PORTD LEDs
		out PORTD,temp
		sec
		rol temp
		rcall delay

        dec temp2
		cpi temp2, 0x00
		brne for2

		ldi temp,0x7f
		out PORTD, temp

      rjmp main
;*********************Delay**************************************************
delay:
          
          ldi coarse, c_del			
cagain:	  ldi medium, m_del		    
magain:	   ldi fine, f_del	        
fagain:	   dec fine
		   brne fagain
		  dec medium
		  brne magain
	     dec coarse
	     brne cagain
	   ret

